#include "utils.hpp"


//------------------------------------------------------------------------------
KUtils::KUtils()
{
}


//------------------------------------------------------------------------------
KUtils::~KUtils()
{
}


//------------------------------------------------------------------------------
//Win komandines eilutes parametrai keiciami i argv tipo eilutes. NULL reiskia,
//  kad daugiau eiluciu nera. Jei pati pirma eilute NULL - reiskia nebuvo parametru.
char ** KUtils::CmdToArgv(char *cmd)
{
	char **argv;

	int kiekis = 0;		//Parametru kiekis
	char *kop = cmd;	//Atsargine adreso kopija
	int ilg;			//Vieno parametro ilgis

	//Skaiciuojamas parametru kiekis
	while(kop[0] != '\0'){
		if(kop[0] == ' ')
			kop++;
		if(kop[0] == '\"'){
			kop++;
			if(strstr(kop, "\"") + 1 < kop + strlen(kop))
				ilg = strstr(kop, "\"") - kop;
			else
				ilg = strlen(kop) - 1;
			kop += ilg + 1;
		}
		else{
			if(strstr(kop, " "))
				ilg = strstr(kop, " ") - kop;
			else
				ilg = strlen(kop);
			kop += ilg;
		}
		++kiekis;
	}
	if(kiekis == 0){
		argv = new char*[1];
		argv[0] = NULL;
		return argv;
	}

	argv = new char*[kiekis + 1];
	argv[kiekis] = NULL;	//NULL reiskia, kad tai paskutine eilute
	kiekis = 0;
	//Parametrai isskiriami is eilutes ir surasomi i masyva
	while(cmd[0] != '\0'){
		if(cmd[0] == ' ')
			cmd++;
		if(cmd[0] == '\"'){
			cmd++;
			if(strstr(cmd, "\"") + 1 < cmd + strlen(cmd))
				ilg = strstr(cmd, "\"") - cmd;
			else
				ilg = strlen(cmd) - 1;
			argv[kiekis] = new char[ilg + 1];
			strncpy(argv[kiekis], cmd, ilg);
			cmd += ilg + 1;
		}
		else{
			if(strstr(cmd, " "))
				ilg = strstr(cmd, " ") - cmd;
			else
				ilg = strlen(cmd);
			argv[kiekis] = new char[ilg + 1];
			strncpy(argv[kiekis], cmd, ilg);
			cmd += ilg;
		}
		argv[kiekis][ilg] = '\0';
		++kiekis;
	}

	return argv;
}


//------------------------------------------------------------------------------
//Gaunama zaidimo direktorija. Adresas uzbaigiamas simboliu '/' arba '\'
char * KUtils::GautiDir()
{
	int poz = 0;
	char *eil = new char[FILENAME_MAX];

	#ifdef OS_WIN32		//Windows kodas
	GetModuleFileName(NULL, eil, FILENAME_MAX);
	for(int i = 0; i < strlen(eil); i++)
		if(eil[i] == '\\' || eil[i] == '/')
			poz = i;
	if(poz > 0)
		eil[poz + 1] = '\0';
	#endif
	#ifdef OS_UNIX		//GNU/Linux kodas
	getcwd(eil, FILENAME_MAX);
	strcat(eil, "/\0");
	#endif

	return eil;
}


//------------------------------------------------------------------------------
//Gaunama zaidimo direktorija, rezultatas irasomas i 'eil'
void KUtils::GautiDir(char *eil)
{
	int poz = 0;
	#ifdef OS_WIN32
	GetModuleFileName(NULL, eil, FILENAME_MAX);
	for(int i = 0; i < strlen(eil); i++)
		if(eil[i] == '\\' || eil[i] == '/')
			poz = i;
	if(poz > 0)
		eil[poz + 1] = '\0';
	#endif
	#ifdef OS_UNIX
	getcwd(eil, MAX_PATH);
	strcat(eil, "/\0");
	#endif
}


//------------------------------------------------------------------------------
//If pilno failo adreso gaunamas failo vardas.
//Grazinama rodykle i vardo pradzia adrese.
char * KUtils::GautiPav(char *eil)
{
	int poz = 0;
	for(int i = 0; i < strlen(eil); i++)
		if(eil[i] == '\\' || eil[i] == '/')
			poz = i;
	if(poz == 0)
		return eil;
	else
		return &eil[poz + 1];
}


//------------------------------------------------------------------------------
//If pilno failo adreso (arba tik vardo) gaunamas failo pletinys.
//Grazinama rodykle i pletinio pradzia adrese.
char * KUtils::GautiPlet(char *eil)
{
	int poz = 0;
	for(int i = 0; i < strlen(eil); i++)
		if(eil[i] == '.')
			poz = i;
	if(poz == 0)
		return NULL;
	else
		return &eil[poz + 1];
}

